/*
    Copyright (C) 2002 Kjetil S. Matheussen / Notam.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <communicate.h>
#include "win/windowsstuff.h"
#include "shmhandler.h"

#define SHAREDMEM_ELEMENTSIZE 1024

struct VSTClient{
  char *name;

  struct Communicate *control_output;
  struct Communicate *process_output;

  struct Communicate *newdelete_input;
  struct Communicate *control_input;
  struct Communicate *process_input;

  pthread_t control_thread;
  pthread_t process_thread;

  int control_thread_status; //0=not connected. 1=connected.
  int process_thread_status; //------------""---------------

  struct WindowsStuff *ws;
  struct SharedMemStuff *sms;

  float **inputs;
  float **outputs;

  pthread_t winwin_thread;

};




void CH_delete(struct VSTClient *client);
struct VSTClient *CH_new(struct VSTS_serverRequest *sr);
