/*
    Copyright (C) 2002 Kjetil S. Matheussen / Notam.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>

#include <vstserver.h>

#include "s_.h"

#include "processthread.h"


void *PROCESS_thread(void *arg){
  struct VSTClient *client=(struct VSTClient *)arg;

  while(C_acceptIncomingConnection(client->process_input)==false);

  client->process_thread_status=1;

  for(;;){
    int sampleframes;
    int num_read=C_receive(client->process_input,&sampleframes,sizeof(int));
    if(num_read!=sizeof(int)){
      if(num_read==0){
	fprintf(stderr,"VSTSERVER/PROCESS_thread: Seems like client has died. Exiting.\n");
	return NULL;
      }else{
	fprintf(stderr,"VSTSERVER/PROCESS_thread: num_read not %d but %d.\n",sizeof(int),num_read);
      }
      continue;
    }

    if(sampleframes==0){
      printf("VSTSERVER/PROCESS_thread: received delete.\n");
      return NULL;
    }

    if(sampleframes>0){
      VSTS_process(client,sampleframes);
    }else{
      VSTS_processReplacing(client,-sampleframes);
    }
  }

  return NULL;
}

